//////////////////////////////////////////////////////////////////////////////////////////////
// Beispiel AnalogIN																		//
//////////////////////////////////////////////////////////////////////////////////////////////


#include <stdio.h>
#include <conio.h>
#include <iostream>
#include <windows.h>

using namespace std;

#include "..\\Goldammer\\MAI_v2_DLL.h"
#if 1
// __stdcall
#pragma comment( lib, "..\\Goldammer\\LIB_STDCALL\\MAI_v2_WIN32_DLL" )
#else
// __cdecl
#pragma comment( lib, "..\\Goldammer\\LIB_CDECL\\MAI_v2_WIN32_DLL" )
#endif




int ErrorHandler(int CardID, int ErrorNumber);

int main()
{
	unsigned int	i						= 0;
	int				Result					= 0;
	int				Status					= 0;
	unsigned int	CardID					= 0;
	unsigned int	NumberOfADChannels		= 4;
    unsigned int	Oversampling			= oversampling2x;
	unsigned int	Gain					= gainDisabled;
	unsigned int	polarity				= polBIPOLAR;
	double			Frequency				= 500;
	unsigned int	StreamingMode			= smOFF;
	unsigned int    ValuesInFifo			= 0;
	int				CapturedValues			= 0;
	unsigned int	ValuesPerChannel		= Frequency /3;
	unsigned int    BlockSize				= 0;
	unsigned int	BlockSizeTemp			= 0;
	unsigned int	MaxValuesToGet			= Frequency * 5;
	unsigned int	CurrentNumberOfValues	= 0;
	unsigned int	PartBlock				= partONLYFULLBLOCKS;
	unsigned int	SkipData				= skipGETCAPTUREDVALUES;

	int			 *  RawData					= 0;
	double		 *  ScaledData				= 0;
	double		 *  ADAnzeige				= 0;




//////////////////////////////////////////////////////////////////////////////////////////////
// CardID der ersten, verfgbaren Karte ausgeben											//
//////////////////////////////////////////////////////////////////////////////////////////////
	CardID = GetFirstDevice();																// gibt die ID der ersten, angeschlossenen Karte zurck


//////////////////////////////////////////////////////////////////////////////////////////////
// Kanallisten lschen																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = ClearAllChannelLists(CardID);													// lscht softwareseitig gehaltene Kanallisten
	if (Result != 0)																		// Fehler
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Kanle der Kanalliste hinzufgen															//
//////////////////////////////////////////////////////////////////////////////////////////////
	for (i = 0; i < NumberOfADChannels; i++)
	{
		Result = AD_AddChannelToList(	CardID,												// ID der anzusprechenden Karte
										i,													// Kanalnummer
										Oversampling,										// Funktion um Strungen des Messsignals zu reduzieren
										Gain,												// Verstrkungsfaktor
										polBIPOLAR  );											// wird vom Basic-Karten nicht untersttzt
		
		if (Result != 0)																	// Fehler
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Frequenz setzen																			//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = AD_SetFrequency(	CardID,														
								Frequency   );												// Abtastrate pro Kanal
	if (Result != 0)																		// Fehler
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Einstellung fr sptere Messwerterfassung												//
//////////////////////////////////////////////////////////////////////////////////////////////
	if (StreamingMode == smON)																// AD-Werte aller Kanle in ein gemeinsames Fifo
	{																						// User muss sich um das zerreien der Daten kmmern
		Result = SetStreamingMode(CardID, StreamingMode);									// StreamingMode aktivieren (Standart: aus)
		if (Result != 0)
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
		BlockSize = ValuesPerChannel * NumberOfADChannels;
	}
	else
		BlockSize = ValuesPerChannel;														// Jeder AD-Kanal hat eigenes Fifo, zerreien nicht mehr ntig

	RawData		= new int[BlockSize];											// Speicher allokieren
	ScaledData	= new double[BlockSize];
	ADAnzeige	= new double[NumberOfADChannels];
	
	memset(RawData, 0, BlockSize);
	memset(ScaledData, 0, BlockSize);
	memset(ADAnzeige, 0, NumberOfADChannels);

	BlockSizeTemp = BlockSize;


//////////////////////////////////////////////////////////////////////////////////////////////
// Parametrieren der Karte und Verarbeitung aller zuvor gettigten Eingaben / Einstellungen //
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = ConfigMeasure(CardID);															
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Messung anstarten																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = StartMeasure(CardID);	
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}
	Status = 1;																				// Messung luft


//////////////////////////////////////////////////////////////////////////////////////////////
// Messdaten abholen																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	while(CurrentNumberOfValues < MaxValuesToGet)											// Schleife wird solange ausgefhrt, bis gewnschter Endwert an Werten erreicht ...
	{
		if(_kbhit()) 
			if (_getch()==27)																// ... oder die Taste "Escape" gedrckt wird
				break;

		Result = AD_GetNumberOfValues(CardID, &ValuesInFifo);										// gibt Anzahl der in den Fifos befindlichen Werte zurck
		if (Result != 0)
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}

		BlockSize = BlockSizeTemp;
		
		if (ValuesInFifo >= BlockSize)														// wenn gengend Werte vorliegen 
		{
			if (StreamingMode == 0)															// wenn jeder AD-Kanal eigenes Fifo verwendet
			{
				for (i = 0; i < NumberOfADChannels; i++)									// jeder ADKanal wird durchlaufen
				{
					Result = AD_ReadData(	CardID,											// ID der verwendeten Karte 
											i,												// Nummer des Kanallisteneintrages (Grund: Wird ein Kanal mehrmals in die Kanalliste aufgenommen, muss zur Unterscheidung die Nummer des Kanallisteneintrages angegeben werden.)
											RawData,										// Daten im 16Bit-Format
											ScaledData,										// Skalierte Daten
											&BlockSize,										// Anzahl der Werte
											PartBlock,										// Ganze Blcke / Teilblcke	(0 - ganz , 1 - teil)
											SkipData    );									// Erfasste Werte verwerfen		(0 - false, 1 - true)
					if (Result != 0)
					{
						ErrorHandler(CardID, Result);
						StopMeasure(CardID);
						system("Pause");
						return 0;
					}
				
					ADAnzeige[i] = ScaledData[0];											// der jeweilig erste Werte wird zur Ausgabe auf der Konsole bereitgestellt
					CurrentNumberOfValues = CurrentNumberOfValues + BlockSize;				// Zhler fr die Anzahl der erfassten Werte
				}
			}
		
			else																			// alle AD-Werte in einem Fifo
			{
				Result = AD_ReadData(	CardID,												// ID der verwendeten Karte 
										0,													// 0, weil alles in einem Fifo
										RawData,											// Daten im 16Bit-Format
										ScaledData,											// Skalierte Daten
										&BlockSize,											// Anzahl der Werte
										PartBlock,											// Ganze Blcke / Teilblcke	(0 - ganz , 1 - teil)
										SkipData    );										// Erfasste Werte verwerfen		(0 - false, 1 - true)
				if (Result != 0)
				{
					ErrorHandler(CardID, Result);
					StopMeasure(CardID);
					system("Pause");
					return 0;
				}
				
				for (i = 0; i < NumberOfADChannels; i++)									// Werte liegen im gelesenen Burst vor: Kanal0, Kanal1, ..., Kanal0, Kanal1
					ADAnzeige[i] = ScaledData[i];

				CurrentNumberOfValues = CurrentNumberOfValues + BlockSize;					// Zhler fr die Anzahl der erfassten Werte
			}

			// lediglich der erste Werte eines Kanals wird auf der Konsole ausgegeben 
			cout << "\r" << CurrentNumberOfValues << "/" << MaxValuesToGet << "   " << ADAnzeige[0] << "   " << ADAnzeige[1] << "   " << ADAnzeige[2] << "   " << ADAnzeige[3];
			Sleep(1);
		}
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Messung anhalten																			//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = StopMeasure(CardID);
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}
	Status = 0;																				// Messung gestoppt


	delete[] RawData;																		// Speicher freigeben
	delete[] ScaledData;																	//
	delete[] ADAnzeige;																		//

	RawData		= 0;
	ScaledData	= 0;
	ADAnzeige	= 0;

	cout << "\nFertig. \n ";
	system("Pause");
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
// Treten negative Rckgabewerte aufgerufener Funktionen auf, liegt ein Fehler vor.			//
// Mittels der ErrorHandler-Funktion wird eine Fehlerbeschreibung zurckgegeben.			//
//////////////////////////////////////////////////////////////////////////////////////////////
int ErrorHandler(int CardID, int ErrorNumber)
{
	char Descr[200];
	GetErrorDescription(CardID, ErrorNumber, Descr);
	cout << "Fehlernummer:  " << ErrorNumber << endl;
	cout << "Beschreibung:  " << Descr << endl;
	return ERROR_SUCCESS;
}
