//////////////////////////////////////////////////////////////////////////////////////////////
// Beispiel AnalogIN_TTL																	//
//////////////////////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <conio.h>
#include <iostream>
#include <windows.h>

using namespace std;

#include "..\\Goldammer\\MAI_v2_DLL.h"
#if 1
// __stdcall
#pragma comment( lib, "..\\Goldammer\\LIB_STDCALL\\MAI_v2_WIN32_DLL" )
#else
// __cdecl
#pragma comment( lib, "..\\Goldammer\\LIB_CDECL\\MAI_v2_WIN32_DLL" )
#endif




int ErrorHandler(int CardID, int ErrorNumber);

int main()
{
	unsigned int	i						= 0;
	int				Result					= 0;
	int				Status					= 0;
	unsigned int	CardID					= 0;
	unsigned int 	NumberOfADChannels		= 2;
	unsigned int	NumberOfTTLChannels		= 1;
	unsigned int	Oversampling			= oversamplingDISABLED;
	unsigned int	Gain					= gainDisabled;
	unsigned int	polarity				= polBIPOLAR;
	double			Frequency				= 2000;
	int				CapturedValues			= 0;
	int				NumberOfValues			= 0;
	unsigned int	ValuesPerChannel		= 200;
	unsigned int	ADBlockSize				= 0;
	unsigned int	TTLBlockSize			= 0;
	unsigned int	ADBlockSizeTemp			= 0;
	unsigned int	TTLBlockSizeTemp		= 0;
	unsigned int	MaxValuesToGet			= 20000;
	unsigned int	CurrentNumberOfValues	= 0;
	unsigned int	PartBlock				= partONLYFULLBLOCKS;
	unsigned int	SkipData				= skipGETCAPTUREDVALUES;

	int			  * RawData					= 0;
	double		  * ScaledData				= 0;
	unsigned int  * TTLData					= 0;
	double		  * ADAnzeige				= 0;





//////////////////////////////////////////////////////////////////////////////////////////////
// CardID der ersten, verfgbaren Karte ausgeben											//
//////////////////////////////////////////////////////////////////////////////////////////////
	CardID = GetFirstDevice();																// gibt die ID der ersten, angeschlossenen Karte zurck


//////////////////////////////////////////////////////////////////////////////////////////////
// Kanallisten lschen																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = ClearAllChannelLists(CardID);													// lscht softwareseitig gehaltene Kanallisten
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Kanle der Kanalliste hinzufgen	(AD + TTL)												//
//////////////////////////////////////////////////////////////////////////////////////////////
	for (i = 0; i < NumberOfADChannels; i++)												// Schleife fr ADKanle
	{
		Result = AD_AddChannelToList(	CardID,												// ID der anzusprechenden Karte
										i,													// Kanalnummer
										Oversampling,										// Funktion um Strungen des Messsignals zu reduzieren
										Gain,												// Verstrkungsfaktor
										polBIPOLAR  );											// wird vom Basic-Karten nicht untersttzt
		if (Result != 0)																		// Fehler
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
	}


	for (i = 0; i != NumberOfTTLChannels; i++)												// TTL Kanle der Kanalliste hinzufgen
	{
		Result = TTL_AddChannelToList(	CardID,												// CardID
										i ,													// Kanal
										true,												// synchron zur AD Kanalliste
										0);													// PortBreite
		if (Result != 0)
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Frequenz setzen																			//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = AD_SetFrequency(	CardID,														// ID der verwendeten Karte										
								Frequency   );												// Analoge Ausgabefrequenz eingeben
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}

	ADBlockSize	= ValuesPerChannel;															// Blockgre in Abhngigkeit der ADKanalanzahl anpassen
	TTLBlockSize = ValuesPerChannel;	

	ADBlockSizeTemp	= ADBlockSize;
	TTLBlockSizeTemp = TTLBlockSize;

	RawData		= new int[ADBlockSize];														// Speicher fr die Werte im 16Bit Format,
	ScaledData	= new double[ADBlockSize];													// Skalierte Werte
	TTLData		= new unsigned int[TTLBlockSize];													// und TTL'er allokieren
	ADAnzeige	= new double[NumberOfADChannels];

	memset(RawData, 0, ADBlockSize);															
	memset(ScaledData, 0, ADBlockSize);
	memset(TTLData, 0, TTLBlockSize);
	memset(ADAnzeige, 0, NumberOfADChannels);


//////////////////////////////////////////////////////////////////////////////////////////////
// Parametrieren der Karte und Verarbeitung aller zuvor gettigten Eingaben/Einstellungen	//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = ConfigMeasure(CardID);															
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Messung anstarten																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = StartMeasure(CardID);	
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}

	Status = 1;																				// Messung luft


//////////////////////////////////////////////////////////////////////////////////////////////
// Messdaten abholen																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	while(CurrentNumberOfValues < MaxValuesToGet)											// Schleife wird solange ausgefhrt, bis gewnschter Endwert an Werten erreicht wird
	{
		if(_kbhit()) 
			if (_getch()==27)																// ... oder die Taste "Escape" gedrckt wird
				break;

		ADBlockSize = ADBlockSizeTemp;
		TTLBlockSize = TTLBlockSizeTemp;

		for (i = 0; i < NumberOfADChannels; i++)
		{
			Result = AD_ReadData(	CardID,													// ID der verwendeten Karte
									i,														// Nummer des Kanals in der Kanalnummer
									RawData,												// Daten im 16Bit Format
									ScaledData,												// Skalierte Daten
									&ADBlockSize,											// Anzahl der abzuholenden Werte, nach Ausfhrung: Anzahl tatschlich gelesener Werte
									PartBlock,												// 
									SkipData);												//
			if (Result != 0)
			{
				ErrorHandler(CardID, CapturedValues);
				system("Pause");
				return 0;
			}
			ADAnzeige[i] = ScaledData[0];													// der jeweilig erste Wert in das AnzeigeArray
			CurrentNumberOfValues = CurrentNumberOfValues + ADBlockSize;					// Zhlwert fr Bedingung fr das Beenden der Schleifenende
		}

		Result = TTL_ReadData(	CardID,														// ID der Karte
								TTLData,													// Daten der TTL'ler
								&TTLBlockSize,												// Blockgre, nach Ausfhrung: Anzahl tatschlich gelesener Werte
								PartBlock,													//
								SkipData);													//
		if (Result != 0)
		{
			ErrorHandler(CardID, CapturedValues);
			system("Pause");
			return 0;
		}

		// Anzeige
		cout << "\r" << CurrentNumberOfValues << "/" << MaxValuesToGet << "    AD0: " << ScaledData[0] << "   AD1: " << ScaledData[1] << "    TTL: " << TTLData[0]<< "             ";
		Sleep(1);

	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Messung anhalten																			//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = StopMeasure(CardID);
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}
	Status = 0;


	delete[] RawData;																		// Speicher freigeben
	delete[] ScaledData;
	delete[] TTLData;
	delete[] ADAnzeige;

	RawData		= 0;
	ScaledData	= 0;
	TTLData		= 0;
	ADAnzeige	= 0;

	cout << "\nFertig. \n ";
	system("Pause");
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
// Treten negative Rckgabewerte aufgerufener Funktionen auf, liegt ein Fehler vor.			//
// Mittels der ErrorHandler-Funktion wird eine Fehlerbeschreibung zurckgegeben.			//
//////////////////////////////////////////////////////////////////////////////////////////////
int ErrorHandler(int CardID, int ErrorNumber)
{
	char Descr[200];
	GetErrorDescription(CardID, ErrorNumber, Descr);
	cout << "Fehlernummer:  " << ErrorNumber << endl;
	cout << "Beschreibung:  " << Descr << endl;
	return ERROR_SUCCESS;
}
