//////////////////////////////////////////////////////////////////////////////////////////////
// Beispiel AnalogIn																		//
//////////////////////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <conio.h>
#include <iostream>
#include <windows.h>

using namespace std;

#include "..\\Goldammer\\MAI_v2_DLL.h"
#if 1
// __stdcall
#pragma comment( lib, "..\\Goldammer\\LIB_STDCALL\\MAI_v2_WIN32_DLL" )
#else
// __cdecl
#pragma comment( lib, "..\\Goldammer\\LIB_CDECL\\MAI_v2_WIN32_DLL" )
#endif



int ErrorHandler(int CardID, int ErrorNumber);

int main()
{
	unsigned int	i						= 0;
	int				Result					= 0;
	int				Status					= 0;
	unsigned int	CardID					= 0;
	unsigned int 	NumberOfADChannels		= 4;
	unsigned int	NumberOfTTLChannels		= 2;
	unsigned int	NumberOfCTChannels		= 1;
	unsigned int	Oversampling			= oversamplingDISABLED;
	unsigned int	Gain					= gainDisabled;
	unsigned int	polarity				= polBIPOLAR;
	double			Frequency				= 5000;
	int				ValuesInFifo			= 0;
	int				CapturedValues			= 0;
	unsigned int 	ValuesPerChannel		= 500;
	unsigned int	ADBlockSize				= 0;
	unsigned int	TTLBlockSize			= 0;
	unsigned int	CTBlockSize				= 0;
	unsigned int	ADBlockSizeTemp			= 0;
	unsigned int	TTLBlockSizeTemp		= 0;
	unsigned int	CTBlockSizeTemp			= 0;
	unsigned int	MaxValuesToGet			= 2000000;
	unsigned int	CurrentNumberOfValues	= 0;

	int			 *  RawData					= 0;
	double		 *  ScaledData				= 0;
	unsigned int *  TTLData					= 0;
	unsigned int *  CTData					= 0;

	double		 *  ADAnzeige				= 0;
	unsigned int *  CTAnzeige				= 0;



//////////////////////////////////////////////////////////////////////////////////////////////
// CardID der ersten, verfgbaren Karte ausgeben											//
//////////////////////////////////////////////////////////////////////////////////////////////
	CardID = GetFirstDevice();																// gibt die ID der ersten, angeschlossenen Karte zurck


//////////////////////////////////////////////////////////////////////////////////////////////
// Kanallisten lschen																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = ClearAllChannelLists(CardID);													// lscht softwareseitig gehaltene Kanallisten
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Kanle der Kanalliste hinzufgen															//
//////////////////////////////////////////////////////////////////////////////////////////////
	for (i = 0; i < NumberOfADChannels; i++)												// Schleife fr AD-Kanle
	{
		Result = AD_AddChannelToList(	CardID,												// ID der anzusprechenden Karte
										i,													// Kanalnummer
										Oversampling,										// Funktion um Strungen des Messsignals zu reduzieren
										Gain,												// Verstrkungsfaktor
										polBIPOLAR  );											// wird vom Basic-Karten nicht untersttzt
		if (Result != 0)																		// Fehler
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
	}

	for (i = 0; i < NumberOfTTLChannels; i++)												// Schleife fr alle TTL Kanle
	{
		Result = TTL_AddChannelToList(	CardID,												// CardID
										i ,													// Kanal
										true,												// synchron zur AD Kanalliste
										0);													// PortBreite		
		if (Result != 0)																		// Fehler ...
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
	}

	for (i = 0; i < NumberOfCTChannels; i++)												// Schleife fr Zhlerkanle
	{
		Result = CT_AddChannelToList(	CardID,												// ID der verwendeten Karte
										i ,													// Zhlerkanal
										true);												// synchron zur AD Kanalliste
		if (Result != 0)
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
		Result = CT_ImpulseCounter(CardID, i, 0, 0, 0);										// Zhlermodus, in diesem Beispiel Impulszhler
		if (Result != 0)
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Frequenz setzen																			//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = AD_SetFrequency(	CardID,														// Analoge Ausgabefrequenz eingeben
								Frequency   );
	if (Result != 0)																			// Rckgabewert kleiner Null --> Fehler!
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}

	ADBlockSize		= ValuesPerChannel;														// Gre des zu allokierenden Speichers berechnen
	TTLBlockSize	= ValuesPerChannel;
	CTBlockSize		= ValuesPerChannel;

	ADBlockSizeTemp = ADBlockSize;
	TTLBlockSizeTemp= TTLBlockSize;
	CTBlockSizeTemp	= CTBlockSize;
	
	RawData			= new int[ADBlockSize];										// Speicher allokieren
	ScaledData		= new double[ADBlockSize];
	TTLData			= new unsigned int[TTLBlockSize];
	CTData			= new unsigned int[CTBlockSize];
	ADAnzeige		= new double[NumberOfADChannels];
	CTAnzeige		= new unsigned int[NumberOfCTChannels];

	memset(RawData, 0, ADBlockSize);														// alle Werte Null setzen
	memset(ScaledData, 0, ADBlockSize);
	memset(TTLData, 0, TTLBlockSize);
	memset(CTData, 0, CTBlockSize);
	memset(ADAnzeige, 0, NumberOfADChannels);
	memset(CTAnzeige, 0, NumberOfCTChannels);

	
//////////////////////////////////////////////////////////////////////////////////////////////
// Parametrieren der Karte und Verarbeitung aller zuvor gettigten Eingaben/Einstellungen	//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = ConfigMeasure(CardID);															
	if (Result != 0)																		// Rckgabewert kleiner Null --> Fehler!
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Messung anstarten																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = StartMeasure(CardID);	
	if (Result != 0)																		// Rckgabewert kleiner Null --> Fehler!
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}
	Status = 1;																				// Messung wurde angestartet / luft


//////////////////////////////////////////////////////////////////////////////////////////////
// Messdaten abholen																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	while(CurrentNumberOfValues < MaxValuesToGet)											// Schleife wird solange ausgefhrt, bis gewnschter Endwert an Werten erreicht wird
	{
		if(_kbhit()) 
			if (_getch()==27)																// ... oder die Taste "Escape" gedrckt wird
				break;

		ADBlockSize  = ADBlockSizeTemp;
		TTLBlockSize = TTLBlockSizeTemp;
		CTBlockSize  = CTBlockSizeTemp;
		
		for (i = 0; i < NumberOfADChannels; i++)											// smtliche ADKanle erfassen
		{
			Result = AD_ReadData(CardID,													// ID der verwendeten Karte
								i,															// Eintrag des Kanals in die Kanalliste
								RawData,													// Daten im 16Bit Format
								ScaledData,													// Skalierte Daten
								&ADBlockSize,												// Gre des abzuholenden Blocks											
								0,															// 
								0);															//
			if (Result != 0)																// Rckgabewert kleiner Null --> Fehler!
			{
				ErrorHandler(CardID, Result);
				StopMeasure(CardID);
				system("Pause");
				return 0;
			}

			if (ADBlockSize)
			{
				CurrentNumberOfValues = CurrentNumberOfValues + ADBlockSize;						// Zhlung der erfassten AD-Werte
				ADAnzeige[i] = ScaledData[0];												// bei erfolgreicher Auslesung werden dem AnzeigeArray Werte zugewiesen
			}
		}

		Result = TTL_ReadData(	CardID,														// ID der Karte
								TTLData,													// Daten der TTL'ler
								&TTLBlockSize,												// Blockgre
								0,															//
								0);															//
		if (Result != 0)																	// Rckgabewert kleiner Null --> Fehler!
		{
			ErrorHandler(CardID, Result);
			StopMeasure(CardID);
			system("Pause");
			return 0;
		}

		for (i = 0; i < NumberOfCTChannels; i++)											// alle Counter Kanle
		{
			Result = CT_ReadData(CardID,													// ID der Karte
								i,															// Eintrag des Kanals in die Kanalliste
								CTData,														// Zhlerwerte
								&CTBlockSize,												// Blockgre
								0,															//
								0);															//
			if (Result != 0)																// Rckgabewert kleiner Null --> Fehler!
			{
				ErrorHandler(CardID, Result);
				StopMeasure(CardID);
				system("Pause");
				return 0;
			}

			if (CTBlockSize)
				CTAnzeige[i] = CTData[0];													// Anzeigewert(e) aufbereiten
		}

						
		//Ausgabe:																	
		system("CLS");
		cout << CurrentNumberOfValues << " von " << MaxValuesToGet << " erfasst\n\n";
		cout << "AD_Kanal_0: " << ADAnzeige[0] << endl;
		cout << "AD_Kanal_1: " << ADAnzeige[1] << endl;
		cout << "AD_Kanal_2: " << ADAnzeige[2] << endl;
		cout << "AD_Kanal_3: " << ADAnzeige[3] << "\n\n";
		cout << "TTL:        " << TTLData[0] << "\n\n";
		cout << "Zaehler_0:  " << CTAnzeige[0] << "\n\n";

		Sleep(5);
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Messung anhalten																			//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = StopMeasure(CardID);
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);														// Rckgabewert kleiner Null --> Fehler!
		system("Pause");
		return 0;
	}
	Status = 0;

	delete[] RawData;																		// Speicher freigeben
	delete[] ScaledData;
	delete[] TTLData;
	delete[] CTData;
	delete[] ADAnzeige;
	delete[] CTAnzeige;

	RawData		= 0;
	ScaledData	= 0;
	TTLData		= 0;
	CTData		= 0;
	ADAnzeige	= 0;
	CTAnzeige	= 0;

	cout << "\nFertig. \n ";
	system("Pause");
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
// Treten negative Rckgabewerte aufgerufener Funktionen auf, liegt ein Fehler vor.			//
// Mittels der ErrorHandler-Funktion wird eine Fehlerbeschreibung zurckgegeben.			//
//////////////////////////////////////////////////////////////////////////////////////////////
int ErrorHandler(int CardID, int ErrorNumber)
{
	char Descr[200];
	GetErrorDescription(CardID, ErrorNumber, Descr);
	cout << "Fehlernummer:  " << ErrorNumber << endl;
	cout << "Beschreibung:  " << Descr << endl;
	return ERROR_SUCCESS;
}
