//////////////////////////////////////////////////////////////////////////////////////////////
// Beispiel AnalogOut																		//
//////////////////////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <conio.h>
#include <iostream>
#include <math.h>

#include <windows.h>

using namespace std;

#include "..\\Goldammer\\MAI_v2_DLL.h"
#if 1
// __stdcall
#pragma comment( lib, "..\\Goldammer\\LIB_STDCALL\\MAI_v2_WIN32_DLL" )
#else
// __cdecl
#pragma comment( lib, "..\\Goldammer\\LIB_CDECL\\MAI_v2_WIN32_DLL" )
#endif



int ErrorHandler(int CardID, int ErrorNumber);

int main()
{
	unsigned int	i						= 0;
	unsigned int	j						= 0;
	int				Result					= 0;	
	int				Status					= 0;
	unsigned int	CardID					= 0;
	unsigned int	NumberOfDAChannels		= 4;
	double			Frequency				= 20;
	unsigned int	FreeFifoSize			= 0;
	int				SetValues				= 0;
	unsigned int	ValuesPerChannel		= 20;
	unsigned int	ValuesPerChTemp			= ValuesPerChannel;								// Merken der zu setzenden Blockgre
	unsigned int	MaxValuesToSet			= 50000;
	unsigned int	CurrentNumberOfValues	= 0;
	unsigned int	PartBlock				= partPARTBLOCK;
	double		  * ScaledData				= 0;


	
//////////////////////////////////////////////////////////////////////////////////////////////
// CardID der ersten, verfgbaren Karte ausgeben											//
//////////////////////////////////////////////////////////////////////////////////////////////
	CardID = GetFirstDevice();																// gibt die ID der ersten, angeschlossenen Karte zurck


//////////////////////////////////////////////////////////////////////////////////////////////
// Kanallisten lschen																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = ClearAllChannelLists(CardID);													// lscht softwareseitig gehaltene Kanallisten
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Kanle der Kanalliste hinzufgen															//
//////////////////////////////////////////////////////////////////////////////////////////////
	for (i = 0; i < NumberOfDAChannels; i++)												// Kanle der Kanalliste hinzufgen
	{
		Result = DA_AddChannelToList(	CardID,												// ID der anzusprechenden Karte
										i   );												// Kanal / Kanallisteneintrag
		if (Result != 0)
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Ausgabefrequenz festlegen																//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = DA_SetFrequency(	CardID,														// ID der anzusprechenden Karte
								Frequency   );												// Ausgabefrequenz
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Messung konfigurieren																	//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = ConfigMeasure(CardID);
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}

	ScaledData = new double[ValuesPerChannel];												// Speicher allokieren
	memset(ScaledData, 0, ValuesPerChannel);


//////////////////////////////////////////////////////////////////////////////////////////////
// Ausgabe anstarten																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = DA_StartOutput(CardID);
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}
	Status = 1;


//////////////////////////////////////////////////////////////////////////////////////////////
// Werte an die Karte senden																//
//////////////////////////////////////////////////////////////////////////////////////////////
	for (j = 0; j < ValuesPerChannel; j++)														
		ScaledData[j] = -10.0 + j ;													// Beispielwerte erstellen (Sgezahn)

	
	while(CurrentNumberOfValues < MaxValuesToSet)
	{
		if(_kbhit()) 
			if (_getch()==27) 
				break;

		ValuesPerChannel = ValuesPerChTemp;

		for(i = 0; i < NumberOfDAChannels; i++)
		{
			if (PartBlock == partONLYFULLBLOCKS)												// Nur ganze Blcke setzen --> ValuesPerChannel
			{
				Result = DA_WriteScaledData(	CardID,										// CardID der verwendeten Karte
												i,											// Kanallisteneintrag des Kanals
												ScaledData,									// Werte
												&ValuesPerChannel,							// Anzahl der Werte, nach der Ausfhrung: Anzahl tatschlich geschriebener Werte
												PartBlock  );								// 
				if (Result != 0)
				{
					ErrorHandler(CardID, SetValues);
					DA_StopOutput(CardID);
					system("Pause");
					return 0;
				}
				CurrentNumberOfValues = CurrentNumberOfValues + ValuesPerChannel;
			}
			else																			// Teilblcke setzen; einfach: Soviel Werte setzen, wieviel im jeilweiligen Kanal Platz ist
			{

				Result = DA_GetFifoState(CardID, i, &FreeFifoSize);							// wieviel Platz ist im Fifo?
				if (Result != 0)
				{
					ErrorHandler(CardID, Result);
					DA_StopOutput(CardID);
					system("Pause");
					return 0;
				}

				if (FreeFifoSize < ValuesPerChannel)										// Platz kleiner als ValuesPerChannel
					ValuesPerChannel = FreeFifoSize;										// Anzahl der zu setzenden Werte dem freien Platz anpassen
				else
					ValuesPerChannel = ValuesPerChTemp;										// ValuesPerChTemp entspricht ValuesPerChannel
					
				if (ValuesPerChannel > 0)													// wenn im Fifo Platz
				{
					Result = DA_WriteScaledData(	CardID,									// CardID der Karte
													i,										// Kanallisteneintrag des Kanals
													ScaledData,								// Werte
													&ValuesPerChannel,						// Anzahl der Werte, nach der Ausfhrung: Anzahl tatschlich geschriebener Werte
													PartBlock  );							//
					if (Result != 0)
					{
						ErrorHandler(CardID, Result);
						DA_StopOutput(CardID);
						system("Pause");
						return 0;
					}
					
					CurrentNumberOfValues = CurrentNumberOfValues + ValuesPerChannel;		// zhlt die gesetzten Werte mit
				}
			}
			cout << "\r" << CurrentNumberOfValues << " von " << MaxValuesToSet << " Werten ausgegeben. FreeFifoSize = " << FreeFifoSize;
			Sleep(4);
		}
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Ausgabe anhalten																			//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = DA_StopOutput(CardID);
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}
	Status = 0;

	delete[] ScaledData;																	// Speicher freigeben
	ScaledData = 0;

	cout << "\nFertig. \n ";
	system("Pause");
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
// Treten negative Rckgabewerte aufgerufener Funktionen auf, liegt ein Fehler vor.			//
// Mittels der ErrorHandler-Funktion wird eine Fehlerbeschreibung zurckgegeben.			//
//////////////////////////////////////////////////////////////////////////////////////////////
int ErrorHandler(int CardID, int ErrorNumber)
{
	char Descr[200];
	GetErrorDescription(CardID, ErrorNumber, Descr);
	cout << "Fehlernummer:  " << ErrorNumber << endl;
	cout << "Beschreibung:  " << Descr << endl;
	return ERROR_SUCCESS;
}
