//////////////////////////////////////////////////////////////////////////////////////////////
// Beispiel FFT																				//
//////////////////////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <conio.h>
#include <iostream>
#include <windows.h>

using namespace std;

#include "..\\Goldammer\\MAI_v2_DLL.h"
#if 1
// __stdcall
#pragma comment( lib, "..\\Goldammer\\LIB_STDCALL\\MAI_v2_WIN32_DLL" )
#else
// __cdecl
#pragma comment( lib, "..\\Goldammer\\LIB_CDECL\\MAI_v2_WIN32_DLL" )
#endif






int ErrorHandler(int CardID, int ErrorNumber);

int main()
{
	unsigned int	i						= 0;
	int				Result					= 0;
	int				Status					= 0;
	unsigned int	CardID					= 0;
	unsigned int	Oversampling			= oversamplingDISABLED;
	unsigned int	Gain					= gainDisabled;
	unsigned int	Bipolar					= polBIPOLAR;
	double			Frequency				= 50000;
	unsigned int	StreamingMode			= smOFF;
	unsigned int    ValuesInFifo			= 0;
	int				CapturedValues			= 0;
	unsigned int	ValuesPerChannel		= 2000;
	unsigned int    BlockSize				= 0;
	unsigned int	BlockSizeTemp			= 0;
	unsigned int	MaxValuesToGet			= 1000000;
	unsigned int	CurrentNumberOfValues	= 0;
	unsigned int	PartBlock				= partONLYFULLBLOCKS;
	unsigned int	SkipData				= skipGETCAPTUREDVALUES;

	int			 *  RawData					= 0;
	double		 *  ScaledData				= 0;


	double			P_Anteil				= 1; 
	double			I_Anteil				= 0;	
	double			D_Anteil				= 0;  
	unsigned int	nPIDType				= pidPID2;  
	double			dGain				    = 1;    
	double			dSollwert				= 3; 
	double			dMIN					= -5;	    
	double			dMAX					= 10;	
	unsigned int	nDAChannelIndex			= 0;	




//////////////////////////////////////////////////////////////////////////////////////////////
// CardID der ersten, verfgbaren Karte ausgeben											//
//////////////////////////////////////////////////////////////////////////////////////////////
	CardID = GetFirstDevice();																// gibt die ID der ersten, angeschlossenen Karte zurck


//////////////////////////////////////////////////////////////////////////////////////////////
// Kanallisten lschen																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = ClearAllChannelLists(CardID);													// lscht softwareseitig gehaltene Kanallisten
	if (Result != 0)																		// Fehler
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}

//////////////////////////////////////////////////////////////////////////////////////////////
// Prfen, ob PID Funktion aktiviert ist   										            //
//////////////////////////////////////////////////////////////////////////////////////////////
	uint nCardsSWExtensions = 0;
	Result = GetSoftwareExtension(CardID,&nCardsSWExtensions);															
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}
	if(((nCardsSWExtensions>>swxOnline_PID)&1)==0){ // Masking the Bit for desired Function
		cout << "Keine FFT Softwareerweiterung auf dieser Karte vorhanden.";
		system("Pause");
		return 0;	
	}

//////////////////////////////////////////////////////////////////////////////////////////////
// Kanal der Kanalliste hinzufgen															//
//////////////////////////////////////////////////////////////////////////////////////////////

		Result = AD_AddChannelToList(	CardID,												// ID der anzusprechenden Karte
										0,													// Kanalnummer
										Oversampling,										// Funktion um Strungen des Messsignals zu reduzieren
										Gain,												// Verstrkungsfaktor
										Bipolar  );											// wird vom Basic-Karten nicht untersttzt
		
		if (Result != 0)																	// Fehler
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}
	 


//////////////////////////////////////////////////////////////////////////////////////////////
// Frequenz setzen																			//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = AD_SetFrequency(	CardID,														
								Frequency   );												// Abtastrate pro Kanal
	if (Result != 0)																		// Fehler
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}



	BlockSize = ValuesPerChannel;														// Jeder AD-Kanal hat eigenes Fifo, zerreien nicht mehr ntig

	RawData		= new int[BlockSize];											// Speicher allokieren
	ScaledData	= new double[BlockSize];
	
	memset(RawData, 0, BlockSize);
	memset(ScaledData, 0, BlockSize);

	BlockSizeTemp = BlockSize;
	Result = Realtime_AddPIDEntry(CardID,   // Card ID
										0,  // Number of AD Channel in Channellist
										P_Anteil,   // P Anteil
										I_Anteil,	// I Anteil
										D_Anteil,   // D Anteil
										nPIDType,   // Controller Type
										dGain,      // Verstrkung
										dSollwert,  // Sollwert/desired value
										dMIN,	    // Minimum Value
										dMAX,		// Maximum Value
										nDAChannelIndex,	// Index of output DA Channel
										Frequency,  // same frequency as ADSamplerate
										NULL);  // Out : Handle to the generated On-Card Online-Function (Some Cards/Functions allow later Change)
	if (Result != 0){		
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}

//////////////////////////////////////////////////////////////////////////////////////////////
// Parametrieren der Karte und Verarbeitung aller zuvor gettigten Eingaben / Einstellungen //
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = ConfigMeasure(CardID);															
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Messung anstarten																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = StartMeasure(CardID);	
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}
	Status = 1;																				// Messung luft


//////////////////////////////////////////////////////////////////////////////////////////////
// Messdaten abholen																		//
//////////////////////////////////////////////////////////////////////////////////////////////
	while(CurrentNumberOfValues < MaxValuesToGet)											// Schleife wird solange ausgefhrt, bis gewnschter Endwert an Werten erreicht ...
	{
		if(_kbhit()) 
			if (_getch()==27)																// ... oder die Taste "Escape" gedrckt wird
				break;

		Result = AD_GetNumberOfValues(CardID, &ValuesInFifo);										// gibt Anzahl der in den Fifos befindlichen Werte zurck
		if (Result != 0)
		{
			ErrorHandler(CardID, Result);
			system("Pause");
			return 0;
		}

		BlockSize = BlockSizeTemp;
		
		if (ValuesInFifo >= BlockSize)														// wenn gengend Werte vorliegen 
		{
	
			Result = AD_ReadData(	CardID,											// ID der verwendeten Karte 
									0,												// Nummer des Kanallisteneintrages (Grund: Wird ein Kanal mehrmals in die Kanalliste aufgenommen, muss zur Unterscheidung die Nummer des Kanallisteneintrages angegeben werden.)
									RawData,										// Daten im 16Bit-Format
									ScaledData,										// Skalierte Daten
									&BlockSize,										// Anzahl der Werte
									PartBlock,										// Ganze Blcke / Teilblcke	(0 - ganz , 1 - teil)
									SkipData    );									// Erfasste Werte verwerfen		(0 - false, 1 - true)
			if (Result != 0){
				ErrorHandler(CardID, Result);
				StopMeasure(CardID);
				system("Pause");
				return 0;
			}
		
													
			CurrentNumberOfValues = CurrentNumberOfValues + BlockSize;				// Zhler fr die Anzahl der erfassten Werte
			
			system("cls");
	
			cout << "Voltage :" << ScaledData[0] << " V   ("<< CurrentNumberOfValues <<"/" << MaxValuesToGet << ")";
			

			Sleep(1);
		}
	}


//////////////////////////////////////////////////////////////////////////////////////////////
// Messung anhalten																			//
//////////////////////////////////////////////////////////////////////////////////////////////
	Result = StopMeasure(CardID);
	if (Result != 0)
	{
		ErrorHandler(CardID, Result);
		system("Pause");
		return 0;
	}
	Status = 0;																				// Messung gestoppt


	delete[] RawData;																		// Speicher freigeben
	delete[] ScaledData;																	//

	RawData		= 0;
	ScaledData	= 0;

	cout << "\nFertig. \n ";
	system("Pause");
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
// Treten negative Rckgabewerte aufgerufener Funktionen auf, liegt ein Fehler vor.			//
// Mittels der ErrorHandler-Funktion wird eine Fehlerbeschreibung zurckgegeben.			//
//////////////////////////////////////////////////////////////////////////////////////////////
int ErrorHandler(int CardID, int ErrorNumber)
{
	char Descr[200];
	GetErrorDescription(CardID, ErrorNumber, Descr);
	cout << "Fehlernummer:  " << ErrorNumber << endl;
	cout << "Beschreibung:  " << Descr << endl;
	return ERROR_SUCCESS;
}
