unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,MAIv2_stdcall, StdCtrls, ExtCtrls, TeEngine, Series, TeeProcs,
  Chart;

type
  TForm1 = class(TForm)
    btn1: TButton;
    lbDevices: TListBox;
    lbl1: TLabel;
    tbADChannel: TEdit;
    singleVlaue: TButton;
    lbl2: TLabel;
    grp1: TGroupBox;
    cht1: TChart;
    fstlnsrsSeries1: TFastLineSeries;
    Start: TButton;
    Stop: TButton;
    lbl3: TLabel;
    eNumVal: TEdit;
    tmr1: TTimer;
    procedure btn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure singleVlaueClick(Sender: TObject);
    procedure StartClick(Sender: TObject);
    procedure StopClick(Sender: TObject);
    procedure tmr1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    procedure StopMeasure();
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  AutoCard, AutoChannel, ValuesInChart : Cardinal;
  InTimerMethod : Boolean;
  Voltages : array [0..5000] of Double;
  RawValues : array [0..5000] of Integer;
implementation

{$R *.dfm}

procedure TForm1.btn1Click(Sender: TObject);
var
  Versi : PChar;
  Versionsinfo : String ;
begin

    Versi := GetDLLVersion();
    Versionsinfo  := 'DLL Version = ' +String(Versi);
    MessageDlg(Versionsinfo, mtInformation	,[mbOK],0);
end;

procedure TForm1.FormShow(Sender: TObject);
var i          : Cardinal;
    CardSerial : String;
begin
  i := 0;
  InTimerMethod := False;
  repeat
        CardSerial := GetSerialNumber(i);
        Inc(i);
        if (CardSerial <> 'MC_ERROR_INVALID_DEVICE') then
          lbDevices.AddItem(CardSerial,TObject(i));

  until  (CardSerial = 'MC_ERROR_INVALID_DEVICE');
  if(i>0)then
    lbDevices.Selected[0] := true;

end;

procedure TForm1.singleVlaueClick(Sender: TObject);
var Voltage : Double;
    Card,Channel :Cardinal;
    VoltAsString : String;
begin
    Card := lbDevices.ItemIndex;
    Channel := StrToInt(tbADChannel.Text);
    AD_ReadSingleVoltage(Card,Channel,0,0,0,@Voltage);
    VoltAsString  := FloatToStr(Voltage);
    MessageDlg(VoltAsString, mtInformation	,[mbOK],0);
end;

procedure TForm1.StartClick(Sender: TObject);

begin
     AutoCard    := lbDevices.ItemIndex;
     AutoChannel := StrToInt(tbADChannel.Text);
     ClearAllChannelLists(AutoCard);
     AD_AddChannelToList(AutoCard,AutoChannel,0,0,1);
     AD_SetFrequency(Autocard,250);
     ConfigMeasure(AutoCard);
     cht1.Series[0].Clear();
     AD_StartMeasure(AutoCard);

     tmr1.Enabled := true;
     Start.Enabled := False;
     Stop.Enabled := True;
     ValuesInChart := 0;

end;



procedure TForm1.StopMeasure();
begin
    tmr1.Enabled := false;
    while(InTimerMethod)  do
      Sleep(250);


    AD_StopMeasure(AutoCard);
    ClearAllChannelLists(AutoCard);
    Start.Enabled := true;
    Stop.Enabled := false;
end;

procedure TForm1.StopClick(Sender: TObject);
begin
    StopMeasure();
end;
procedure TForm1.tmr1Timer(Sender: TObject);
var
  i,NumberOfValues : Cardinal;

begin
     InTimerMethod := true;
  try
    AD_GetNumberOfValues(AutoCard,@NumberOfValues);
    AD_ReadData(AutoCard,0,@RawValues,@Voltages,@NumberOfValues,0,0);
    eNumVal.Text := IntToStr(NumberOfValues);
    if(  NumberOfValues > 0)     then
    begin
       cht1.Series[0].Add(Voltages[0]);

      (* if ValuesInChart < 20 then
          Inc(ValuesInChart)
       else
          cht1.Series[0].Delete(0);
        cht1.Refresh();   *)
    end;
    finally
      InTimerMethod := false;
    end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  StopMeasure();
end;

end.
