unit UAnalogOUT;


interface

implementation
uses
  SysUtils,
  ConsoleHelper,
  MAI_v2_DLL;


var
  CardID                  : Cardinal;
  i,j,Result              : Integer;
  NumberOfDAChannels, ValuesPerChannel,CurrentNumberOfValues,MaxValuesToSet,FreeFifoSize       : Cardinal;
  KeyThatWasPressed       : AnsiChar;
  ScaledData              : array of Double;
begin
//////////////////////////////////////////////////////////////////////////////////////////////
//  Parameter der Messung	                                                       						//
//////////////////////////////////////////////////////////////////////////////////////////////
  NumberOfDAChannels  := 4;
  ValuesPerChannel		:= 20;
  MaxValuesToSet			:= 50000;
//////////////////////////////////////////////////////////////////////////////////////////////
//  CardID der ersten, verfgbaren Karte verwenden	                             						//
//////////////////////////////////////////////////////////////////////////////////////////////
  CardID := GetFirstDevice();
	if (CardID < 0) then
	begin
		PrintError(CardID, CardID);
	 	Exit;
	end;
  WriteLn('Verwende Karte mit ID 0.');
  Writeln('Serial Number : '+GetSerialNumber(CardID));            // Seriennummer der Karte
//////////////////////////////////////////////////////////////////////////////////////////////
// Kanallisten lschen																		                                   //
//////////////////////////////////////////////////////////////////////////////////////////////
	Result := ClearAllChannelLists(CardID);													// lscht softwareseitig gehaltene Kanallisten
	if (Result <> 0) then
	begin
		PrintError(CardID, CardID);
	 	Exit;
 	end;

//////////////////////////////////////////////////////////////////////////////////////////////
// Kanle der Kanalliste hinzufgen															                            //
//////////////////////////////////////////////////////////////////////////////////////////////
	for i := 0 to NumberOfDAChannels-1 do											// Kanle der Kanalliste hinzufgen
	begin 
		Result := DA_AddChannelToList(	CardID,												// ID der anzusprechenden Karte
										                i   );												// Kanal / Kanallisteneintrag
    if (Result <> 0) then
    begin
      PrintError(CardID, CardID);
      Exit;
    end;
	end; 

//////////////////////////////////////////////////////////////////////////////////////////////
// Ausgabefrequenz festlegen																                                //
//////////////////////////////////////////////////////////////////////////////////////////////
	Result := DA_SetFrequency(	CardID,												 // ID der anzusprechenden Karte
								              20   );												 // Ausgabefrequenz
	if (Result <> 0) then 
	begin 
    PrintError(CardID, CardID);
    Exit;
	end;

//////////////////////////////////////////////////////////////////////////////////////////////
// Messung konfigurieren																	                                  //
//////////////////////////////////////////////////////////////////////////////////////////////
	Result := ConfigMeasure(CardID);
	if (Result <> 0) then
	begin
    PrintError(CardID, CardID);
    Exit;
	end;

  SetLength(ScaledData, ValuesPerChannel);
	for j := 0 to ValuesPerChannel-1 do
		ScaledData[j] := -10.0 + j ;

//////////////////////////////////////////////////////////////////////////////////////////////
// Ausgabe anstarten																                                        //
//////////////////////////////////////////////////////////////////////////////////////////////
	Result := DA_StartOutput(CardID);
	if (Result <> 0) then 
	begin 
    PrintError(CardID, CardID);
    Exit;
	end;



//////////////////////////////////////////////////////////////////////////////////////////////
// Werte an die Karte senden																                                //
//////////////////////////////////////////////////////////////////////////////////////////////
   CurrentNumberOfValues :=0;
	while (CurrentNumberOfValues < MaxValuesToSet) do
	begin
    if (KeyPressed(KeyThatWasPressed)) then
    begin
        if(KeyThatWasPressed = #27) then
        begin
           WriteLn('Sie haben <ESC> gedrueckt.');
				   break;
        end;

    end;



		for i := 0 to NumberOfDAChannels-1 do
		begin


      Result := DA_GetFifoState(CardID, i, FreeFifoSize);							// wieviel Platz ist im Fifo?
      if (Result <> 0) then
      begin
       PrintError(CardID, CardID);
       break;
      end;

			if (FreeFifoSize >=  ValuesPerChannel) then
			begin
				Result := DA_WriteScaledData(	CardID,										// CardID der verwendeten Karte
                                      i,											// Kanallisteneintrag des Kanals
                                      @ScaledData[0],									// Werte
                                      ValuesPerChannel,							// Anzahl der Werte, nach der Ausfhrung: Anzahl tatschlich geschriebener Werte
                                      partONLYFULLBLOCKS  );								//
				if (Result <> 0) then 
				begin
          PrintError(CardID, CardID);
          break;
				end;
				CurrentNumberOfValues := CurrentNumberOfValues + ValuesPerChannel;
			end;
      Write(Char(13)+'  ' + InttoStr( currentNumberOfValues )+ '/' + InttoStr( MaxValuesToSet )+' Werte ausgegeben. FreeFifoSize = ' +InttoStr( FreeFifoSize ));
			Sleep(4);
		end;
	end; 


//////////////////////////////////////////////////////////////////////////////////////////////
// Ausgabe anhalten																			                                    //
//////////////////////////////////////////////////////////////////////////////////////////////
	Result := DA_StopOutput(CardID);
	if (Result <> 0) then
	begin 
   PrintError(CardID, CardID);
   Exit;
	end;

  WriteLn;
  WriteLn;
  Writeln('Fertig. (Bitte <Enter> druecken...)');
  Read(KeyThatWasPressed);
end.
