unit MAI_v2_DLL;

interface


type
	TOversampling = (oversamplingDISABLED, oversampling2x, oversampling4x, oversampling8x, oversampling16x); 
	TGain = (gainDisabled, gain2x, gain4x, gain8x); 
	TBipolar = (polUNIPOLAR, polBIPOLAR); 
	TPartBlock = (partONLYFULLBLOCKS, partPARTBLOCK); 
	TSkipData = (skipGETCAPTUREDVALUES, skipSKIPCAPTUREDVALUES); 
	TStreamingMode = (smOFF, smON); 
	TCounterMode = (cmFREQUENCYCOUNTER, cmPERIODCOUNTER, cmPULSWIDTHCOUNTER, cmINCREMENTALCOUNTER, cmIMPULSECOUNTER); 
	TTrigger = (trigDISABLED, trigEXTERN_TRIGGER, trigEXTERN_CLOCK); 
	TExternEdge = (tedgeFALLING_EDGE, tedgeRISING_EDGE); 
	TFFT_Type = (fftAbsolute = 0, fftRMS = 1, fftPower = 2, fftPhase = 3); 
	TFFT_Size = (fft_s512 = 0, fft_s1024 = 1, fft_s2048 = 2, fft_s4096 = 3); 
	TTrigger_Type = (trigMax = 0, trigMin = 1, trigUnterSchwelle = 2, trigUeberSchwelle = 3, trigFenster = 4, trigUnterGradientensteigung = 5, trigUeberGradientensteigung = 6, trigGradientenfenster = 7); 
	TPIDControllerType = (pidPID1 = 0, pidPID2 = 1, pidPID3 = 2); 
	TFilterType = (ftLOWPASS = 0, ftHIGHPASS = 1, ftBANDPASS = 2, ftBANDSTOP = 3); 
	TIIRFilterDesign = (iirBUTTERWORTH = 0, iirCHEBYSHEV_T1 = 1, iirCHEBYSHEV_T2 = 2, iirELLIPTIC = 3, iirBESSEL = 4); 
	TFIRWindowFunction = (firwinRectangular = 0, firwinHanning = 1, firwinHamming = 2, firwinBlackman = 3, firwinKaiser = 4, firwinBartlett = 5, firwinDolph_Tschebytschow = 6, firwinTriangular = 7, firwinBlackman_Harris = 8, firwinBlackman_Nuttall = 9, firwinFlat_Top = 10); 
	TSWExtensionsBitNumber = (swxOnline_FFT = 0, swxOnline_Filter = 1, swxOnline_PID = 2, swxOnline_Linearisierung = 3, swxOnboardFunktionsgenerator = 4, swxWabco_Projekt = 9, swxAirbag_Pruefstand = 14, swxUpDown_Card = 15, swxExtended_Stoptrigger = 16); 
	THWExtensionsBitNumber = (hwxZaehlerupgrade = 0, hwxUpDown_Counter = 1, hwxPWM_Ausgabe = 2, hwxPWM_Karte = 3, hwxDA_Wandler = 4, hwxMultiplexerUeberspannungsschutz = 5, hwxDualWandler = 8, hwxZeitstempel = 9, hwxTTL_Bitweise = 10, hwxCoprozessor_56307 = 11, hwxCoprozessor_56311 = 12, hwxInkrementalzaehler = 13, hwxRegeneratorAutomotiv = 14, hwxMH_Zaehlererweiterung = 15, hwxSSI_Schnittstelle = 16, hwxThermoelementanschluss_8Kanal = 17, hwx32Bit_Counter = 18, hwxICP_Einspeisung = 19); 
	TIEPEMode			         = (iepeDC_SE_IEPE_off= 0,	iepeDC_Diff_IEPE_off= 1,iepeAC_SE_IEPE_off= 2,iepeAC_SE_IEPE_on= 3);
	TDigitalPortType   = ( dptBit, dptByte, dptWord);
	
	
// (Device) Pool functions	
function GetFirstDevice():LongInt; stdcall; external 'maiv2dll.DLL' name 'GetFirstDevice';
function GetFirstDeviceByType(DeviceType: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetFirstDeviceByType';
function OpenDevice(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'OpenDevice';
function CloseDevice(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'CloseDevice';
function IsDeviceOpen(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'IsDeviceOpen';
function GetErrorDescription(nInstance: Cardinal; ErrorNumber: Integer; ErrorDescription: PAnsiChar):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetErrorDescription';
function SetGPCIFile(AIFilePath: PAnsiChar):LongInt; stdcall; external 'maiv2dll.DLL' name 'SetGPCIFile';

// general functions
function ClearAllChannelLists(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'ClearAllChannelLists';
function StartMeasure(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'StartMeasure';
function StopMeasure(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'StopMeasure';
function SetStreamingMode(nInstance: Cardinal; nStreamingMode: TStreamingMode):LongInt; stdcall; external 'maiv2dll.DLL' name 'SetStreamingMode';
function SetRunningMode(nInstance: Cardinal; MasterSlave: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'SetRunningMode';
function SetRunningModeEx(nInstance: Cardinal; MasterSlave: Cardinal; AIMultipleMastersAllowed: Boolean):LongInt; stdcall; external 'maiv2dll.DLL' name 'SetRunningModeEx';
function EnableSoftwareClock(nInstance: Cardinal; AIFetchADDataInUserMode: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'EnableSoftwareClock';
function ConfigCard(nInstance: Cardinal; TriggerExtern: TTrigger; ExternEdge: TExternEdge; DifferenzMode: Boolean; p4: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'ConfigCard';
function SetGlobalTriggerValues(nInstance: Cardinal; nPreTrigger: Cardinal; nPostTrigger: Cardinal; nWaitForStartTrigger: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'SetGlobalTriggerValues';
function ConfigMeasure(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'ConfigMeasure';
function IdentifierDevice(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'IdentifierDevice';
function IsUSBHighSpeed(nInstance: Cardinal; var IsUSBHighSpeed: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'IsUSBHighSpeed';
function GetCardName(nInstance: Cardinal):PAnsiChar; stdcall; external 'maiv2dll.DLL' name 'GetCardName';
function GetCardProducer(nInstance: Cardinal):PAnsiChar; stdcall; external 'maiv2dll.DLL' name 'GetCardProducer';
function GetCardSeller(nInstance: Cardinal):PAnsiChar; stdcall; external 'maiv2dll.DLL' name 'GetCardSeller';
function GetManufacture_Name(nInstance: Cardinal):PAnsiChar; stdcall; external 'maiv2dll.DLL' name 'GetManufacture_Name';
function GetSerialNumber(nInstance: Cardinal):PAnsiChar; stdcall; external 'maiv2dll.DLL' name 'GetSerialNumber';
function GetCustomer_Name(nInstance: Cardinal):PAnsiChar; stdcall; external 'maiv2dll.DLL' name 'GetCustomer_Name';
function GetCustomer_Number(nInstance: Cardinal):PAnsiChar; stdcall; external 'maiv2dll.DLL' name 'GetCustomer_Number';
function GetCustomer_DateOfPurchase(nInstance: Cardinal):PAnsiChar; stdcall; external 'maiv2dll.DLL' name 'GetCustomer_DateOfPurchase';
function GetADChannels(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetADChannels';
function GetADSampleWidth(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetADSampleWidth';
function GetADSampleRate(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetADSampleRate';
function GetDAChannels(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetDAChannels';
function GetDASampleWidth(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetDASampleWidth';
function GetDASampleRate(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetDASampleRate';
function GetTTLChannels(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetTTLChannels';
function GetTTLSampleWidth(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetTTLSampleWidth';
function GetTTLSampleRate(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetTTLSampleRate';
function GetCTChannels(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetCTChannels';
function GetCTSampleWidth(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetCTSampleWidth';
function GetCTSampleRate(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetCTSampleRate';
function GetPWMChannels(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetPWMChannels';
function GetPWMSampleWidth(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetPWMSampleWidth';
function GetPWMSampleRate(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetPWMSampleRate';
function GetSoftwareExtension(nInstance: Cardinal; var pSWExtension: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetSoftwareExtension';
function GetHardwareExtension(nInstance: Cardinal; var pHWExtension: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetHardwareExtension';
function GetMeasurementProcessorVersion(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetMeasurementProcessorVersion';
function GetControllerFirmwareVersion(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetControllerFirmwareVersion';
function GetSystemDriverVersion(nInstance: Cardinal; DLLVersion: PAnsiChar):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetSystemDriverVersion';
function PrivateFlashDataRead(nInstance: Cardinal; PrivateData: PAnsiChar; nLength: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'PrivateFlashDataRead';
function PrivateFlashDataWrite(nInstance: Cardinal; PrivateData: PAnsiChar; nLength: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'PrivateFlashDataWrite';
function PrivateFlashDataClear(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'PrivateFlashDataClear';
function GetDLLVersion():PAnsiChar; stdcall; external 'maiv2dll.DLL' name 'GetDLLVersion';
function GetLIBVersion():PAnsiChar; stdcall; external 'maiv2dll.DLL' name 'GetLIBVersion';
function GetCardIDBySerial(Serial: PAnsiChar; var nCardID: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetCardIDBySerial';
function GetDeviceInfo(nCardID: Cardinal; var nDeviceType: Integer; Serial: PAnsiChar):LongInt; stdcall; external 'maiv2dll.DLL' name 'GetDeviceInfo';



// AD_Functions
function AD_ClearChannelList(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'AD_ClearChannelList';
function AD_AddChannelToList(nInstance: Cardinal; nChannel: Cardinal; nOversampling: TOversampling; nGain: TGain; nBipolar: TBipolar):LongInt; stdcall; external 'maiv2dll.DLL' name 'AD_AddChannelToList';
function AD_GetChannelListSize(nInstance: Cardinal; var nCLSize: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'AD_GetChannelListSize';
function AD_ReadSingleValue(nInstance: Cardinal; nChannel: Cardinal; nOversampling: TOversampling; nGain: TGain; nBipolar: TBipolar; var nRawValue: Integer):LongInt; stdcall; external 'maiv2dll.DLL' name 'AD_ReadSingleValue';
function AD_ReadSingleVoltage(nInstance: Cardinal; nChannel: Cardinal; nOversampling: TOversampling; nGain: TGain; nBipolar: TBipolar; var bVoltage: Double):LongInt; stdcall; external 'maiv2dll.DLL' name 'AD_ReadSingleVoltage';
function AD_SetFrequency(nInstance: Cardinal; fFrequency: Double):LongInt; stdcall; external 'maiv2dll.DLL' name 'AD_SetFrequency';
function AD_GetFrequency(nInstance: Cardinal; var fFrequency: Double):LongInt; stdcall; external 'maiv2dll.DLL' name 'AD_GetFrequency';
function AD_ReadLastBurst(nInstance: Cardinal; RawData: PInteger; Value: PDouble; var nNumberOfValues: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'AD_ReadLastBurst';
function AD_ReadData(nInstance: Cardinal; nChannelListEntry: Cardinal; RawData: PInteger; Value: PDouble; var nValuesPerChannel: Cardinal; bPartBlock: TPartBlock; bSkipData: TSkipData):LongInt; stdcall; external 'maiv2dll.DLL' name 'AD_ReadData';
function AD_ReadBinaryData(nInstance: Cardinal; BinaryData: PByte; var nLength: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'AD_ReadBinaryData';
function AD_GetStreamPipeLevel(nInstance: Cardinal; var fStreamPipeLevel: Double):LongInt; stdcall; external 'maiv2dll.DLL' name 'AD_GetStreamPipeLevel';
function AD_GetNumberOfValues(nInstance: Cardinal; var nNumberOfValues: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'AD_GetNumberOfValues';
function AD_StartMeasure(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'AD_StartMeasure';
function AD_StopMeasure(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'AD_StopMeasure';
function AD_SetIEPE(nInstance: Cardinal; nChannel: Cardinal; nIEPEMode: TIEPEMode; Set20DBGain: Boolean):LongInt; stdcall; external 'maiv2dll.DLL' name 'AD_SetIEPE';
function AD_ResetIEPE(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'AD_ResetIEPE';

// DA_Functions

function DA_SetRange(nInstance: Cardinal; nRange: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'DA_SetRange';
function DA_ClearChannelList(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'DA_ClearChannelList';
function DA_AddChannelToList(nInstance: Cardinal; nChannel: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'DA_AddChannelToList';
function DA_GetChannelListSize(nInstance: Cardinal; var nCLSize: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'DA_GetChannelListSize';
function DA_SetFrequency(nInstance: Cardinal; fFrequency: Double):LongInt; stdcall; external 'maiv2dll.DLL' name 'DA_SetFrequency';
function DA_StartOutput(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'DA_StartOutput';
function DA_StopOutput(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'DA_StopOutput';
function DA_WriteChannelRaw(nInstance: Cardinal; nChannel: Cardinal; RawValue: Integer):LongInt; stdcall; external 'maiv2dll.DLL' name 'DA_WriteChannelRaw';
function DA_WriteChannelVoltage(nInstance: Cardinal; nChannel: Cardinal; VoltageValue: Double):LongInt; stdcall; external 'maiv2dll.DLL' name 'DA_WriteChannelVoltage';
function DA_WriteRawData(nInstance: Cardinal; nChannelListEntry: Cardinal; pBuffer: PInteger; var nLength: Cardinal; bPartBlock: TPartBlock):LongInt; stdcall; external 'maiv2dll.DLL' name 'DA_WriteRawData';
function DA_WriteScaledData(nInstance: Cardinal; nChannelListEntry: Cardinal; fScaledValues: PDouble; var nLength: Cardinal; bPartBlock: TPartBlock):LongInt; stdcall; external 'maiv2dll.DLL' name 'DA_WriteScaledData';
function DA_GetFifoState(nInstance: Cardinal; nChannel: Cardinal; var nNumberOfValues: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'DA_GetFifoState';


// CT_Functions

function CT_ClearChannelList(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'CT_ClearChannelList';
function CT_AddChannelToList(nInstance: Cardinal; nChannel: Cardinal; bToADChannellist: Boolean):LongInt; stdcall; external 'maiv2dll.DLL' name 'CT_AddChannelToList';
function CT_GetChannelListSize(nInstance: Cardinal; var nCLSize: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'CT_GetChannelListSize';
function CT_SetFrequency(nInstance: Cardinal; fFreqency: Double):LongInt; stdcall; external 'maiv2dll.DLL' name 'CT_SetFrequency';
function CT_SetResolution(nInstance: Cardinal; nChannel: Cardinal; nResolution: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'CT_SetResolution';
function CT_ImpulseCounter(nInstance: Cardinal; nChannel: Cardinal; nPresetValue: Cardinal; nUpDown: Cardinal; nEdge: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'CT_ImpulseCounter';
function CT_FrequencyCounter(nInstance: Cardinal; nChannel: Cardinal; nResolution: Cardinal; nEdge: Cardinal; nEachPeriod: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'CT_FrequencyCounter';
function CT_PeriodCounter(nInstance: Cardinal; nChannel: Cardinal; nResolution: Cardinal; nEdge: Cardinal; nEachPeriod: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'CT_PeriodCounter';
function CT_PulswidthCounter(nInstance: Cardinal; nChannel: Cardinal; nResolution: Cardinal; nEdge: Cardinal; nEachPeriod: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'CT_PulswidthCounter';
function CT_IncrementalCounter(nInstance: Cardinal; nChannel: Cardinal; nResolution: Cardinal; nEdge: Cardinal; nSoftwareReset: Cardinal; nHardwareReset: Cardinal; nHWResetEdge: Cardinal; nInterpolation: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'CT_IncrementalCounter';
function CT_UpDownCounter(nInstance: Cardinal; nChannel: Cardinal; nPresetValue: Cardinal; nUpDown: Cardinal; nEdge: Cardinal; nSoftwareReset: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'CT_UpDownCounter';
function CT_ReadData(nInstance: Cardinal; nChannelListEntry: Cardinal; pBuffer: PCardinal; var nNumberOfValues: Cardinal;  bPartBlock: TPartBlock; bSkipData: TSkipData):LongInt; stdcall; external 'maiv2dll.DLL' name 'CT_ReadData';
function CT_ReadSingleValue(nInstance: Cardinal; nChannel: Cardinal; var SingleValue: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'CT_ReadSingleValue';
function CT_GetStreamPipeLevel(nInstance: Cardinal; var fStreamPipeLevel: Double):LongInt; stdcall; external 'maiv2dll.DLL' name 'CT_GetStreamPipeLevel';
function CT_GetNumberOfValues(nInstance: Cardinal; var nNumberOfValues: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'CT_GetNumberOfValues';
function CT_StartMeasure(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'CT_StartMeasure';
function CT_StopMeasure(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'CT_StopMeasure';

// TTL_Functions (DIN/DOUT)

function TTL_ClearChannelList(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'TTL_ClearChannelList';
function TTL_AddChannelToList(nInstance: Cardinal; nChannel: Cardinal; bToADList: Boolean; nDigitalType: TDigitalPortType):LongInt; stdcall; external 'maiv2dll.DLL' name 'TTL_AddChannelToList';
function TTL_GetChannelListSize(nInstance: Cardinal; var nCLSize: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'TTL_GetChannelListSize';
function TTL_SetFrequency(nInstance: Cardinal; fFrequency: Double):LongInt; stdcall; external 'maiv2dll.DLL' name 'TTL_SetFrequency';
function TTL_SetChannelDirection(nInstance: Cardinal; nChannel: Cardinal; nDirectionValue: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'TTL_SetChannelDirection';
function TTL_GetChannelDirection(nInstance: Cardinal; nChannel: Cardinal; var nDirection: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'TTL_GetChannelDirection';
function TTL_ReadData(nInstance: Cardinal; pBuffer: PCardinal; var nNumberOfValues: Cardinal;  bPartBlock: TPartBlock; bSkipData: TSkipData):LongInt; stdcall; external 'maiv2dll.DLL' name 'TTL_ReadData';
function TTL_ReadPort(nInstance: Cardinal; nPort: Cardinal; var nPortValue: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'TTL_ReadPort';
function TTL_WritePort(nInstance: Cardinal; nPort: Cardinal; nPortValue: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'TTL_WritePort';
function TTL_ReadBit(nInstance: Cardinal; nChannel: Cardinal; var nBit: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'TTL_ReadBit';
function TTL_WriteBit(nInstance: Cardinal; nChannel: Cardinal; nBit: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'TTL_WriteBit';
function TTL_GetStreamPipeLevel(nInstance: Cardinal; var fStreamPipeLevel: Double):LongInt; stdcall; external 'maiv2dll.DLL' name 'TTL_GetStreamPipeLevel';
function TTL_GetNumberOfValues(nInstance: Cardinal; var nNumberOfValues: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'TTL_GetNumberOfValues';
function TTL_InitializeTargetSettings(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'TTL_InitializeTargetSettings';
function TTL_StartMeasure(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'TTL_StartMeasure';
function TTL_StopMeasure(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'TTL_StopMeasure';
function TTL_GetPortInfos(nInstance: Cardinal; var NumberOfPorts: Cardinal; var PortWidth: Cardinal; var NumberOfDigIn: Cardinal; var NumberOfDigOut: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'TTL_GetPortInfos';


// SSI Functions (only apply to DSP cards with corresponding HW extensions installed)
function SSI_SetBitWidth(nInstance: Cardinal; nBitWidth: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'SSI_SetBitWidth';
function SSI_ConfigSSI(nInstance: Cardinal; nReset: Cardinal; nResetEdge: Cardinal; nActivePassiveMode: Cardinal; nClockFrequency: Cardinal; nEdge: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'SSI_ConfigSSI';

// PWM Functions (only apply to DSP cards with corresponding SW extensions installed)
function PWM_StartOutput(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'PWM_StartOutput';
function PWM_StopOutput(nInstance: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'PWM_StopOutput';
function PWM_PreparePWMOutput(nInstance: Cardinal; nChannel: Cardinal; StartFrequency: Cardinal; nStartRatio: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'PWM_PreparePWMOutput';
function PWM_PrepareFMOutput(nInstance: Cardinal; nChannel: Cardinal; StartFrequency: Cardinal; nPulsWidthRatio: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'PWM_PrepareFMOutput';
function PWM_WriteNewPWMRatio(nInstance: Cardinal; nChannel: Cardinal; nRatio: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'PWM_WriteNewPWMRatio';
function PWM_WriteNewFMFrequency(nInstance: Cardinal; nChannel: Cardinal; Frequency: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'PWM_WriteNewFMFrequency';
function PWM_GetPWMRatio(nInstance: Cardinal; nChannel: Cardinal; var nRatio: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'PWM_GetPWMRatio';
function PWM_GetFMFrequency(nInstance: Cardinal; nChannel: Cardinal; var Frequency: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'PWM_GetFMFrequency';


// Online Functions (only apply to DSP cards with corresponding SW extensions installed)
function Realtime_AddTriggerEntry(nInstance: Cardinal; nChannelListEntry: Cardinal; nStartTriggerAktiv: Cardinal; dStartSchwellwert1: Double; dStartSchwellwert2: Double; nStartTriggerTyp: TTrigger_Type; nStartEnableAtStart: Cardinal; nStartTriggerMessung: Cardinal; nStartTriggerSetTTL: Cardinal; nStartTriggerTTLKlemme: Cardinal; nStartTriggerTTLZustand: Cardinal; nStartTriggerTTLFlanke: Cardinal; nStopTriggerAktiv: Cardinal; dStopSchwellwert1: Double; dStopSchwellwert2: Double; nStopTriggerTyp: TTrigger_Type; nStopEnableAtStart: Cardinal; nStopTriggerMessung: Cardinal; nStopTriggerSetTTL: Cardinal; nStopTriggerTTLKlemme: Cardinal; nStopTriggerTTLZustand: Cardinal; nStopTriggerTTLFlanke: Cardinal; nRetriggerbar: Cardinal; var AOIndexInChannelsRTList: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'Realtime_AddTriggerEntry';
function Realtime_AddFilterEntry(nInstance: Cardinal; AIChannelListEntry: Cardinal; AIFilterMode: Cardinal; AIFilterOrder: Cardinal;  AICoefficients: PDouble; AIOutputGainFactor: Double; var AOIndexIndChannelsRTList: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'Realtime_AddFilterEntry';
function Realtime_DesignIIRFilter(AISampleRate: Double; AIFilterType: TFilterType; AICutoffFreqency: Double; AICutoffFreqency2: Double; AIFrequenciesAreNormalized: Boolean; AIPassabsorbtion: Double; AIStopbandattenuation: Double; AIDesignMethod: TIIRFilterDesign; AIOrder: Cardinal; var AOFilterMode: Cardinal; AOCoefficientsList: PDouble):LongInt; stdcall; external 'maiv2dll.DLL' name 'Realtime_DesignIIRFilter';
function Realtime_DesignFIRFilter(AISampleRate: Double; AIFilterType: TFilterType; AICutoffFreqLow: Double; AICutoffFreqHigh: Double; AIFrequenciesAreNormalized: Boolean; AIOrder: Cardinal; AIFilterWindow: TFIRWindowFunction; AIWindowParameter: Double; AIScalePassband: Boolean; var AOFilterMode: Cardinal; AOCoefficientsList: PDouble):LongInt; stdcall; external 'maiv2dll.DLL' name 'Realtime_DesignFIRFilter';
function Realtime_AddPIDEntry(nInstance: Cardinal; nChannelListEntry: Cardinal; dPAnteil: Double; dIAnteil: Double; dDAnteil: Double; nReglerArt: TPIDControllerType; Gain: Double; dSollwert: Double; dMinValue: Double; dMaxValue: Double; nDAKanal: Cardinal; nSampleFreq: Double; var AOIndexInChannelsRTList: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'Realtime_AddPIDEntry';
function Realtime_AddFFTEntry(nInstance: Cardinal; nChannelListEntry: Cardinal; nAnzahlPunkte: TFFT_Size; nSpektrum: TFFT_Type; dGain: Double; nFensterFunktion: TFIRWindowFunction; dParameter: Double; var AOIndexInChannelsRTList: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'Realtime_AddFFTEntry';
function Realtime_FFT_ReadData(nInstance: Cardinal; nChannelListEntry: Cardinal; FFTData: PDouble; var nNumberOfValues: Cardinal):LongInt; stdcall; external 'maiv2dll.DLL' name 'Realtime_FFT_ReadData';


procedure PrintError(CardID : Cardinal; ErrorNumber : Integer);

implementation

uses   SysUtils, Windows;

procedure PrintError(CardID : Cardinal; ErrorNumber : Integer);
var
    myString  : AnsiString;
    len : cardinal;
begin
    if(ErrorNumber <> 0) then
    begin
        myString := '                                                                                                                                                                                   ';
        GetErrorDescription(CardID, ErrorNumber, Addr( myString[1]));
        len :=  Pos(#0,myString)   ;
        SetLength(myString, len);
        Writeln('Fehlernummer:  '+ IntTostr(ErrorNumber));
        Writeln('Beschreibung: '+ myString);
        Writeln('(Bitte <Enter> druecken...)');
        Readln(myString);
    end;

end;

end.
