unit USingleAD;

interface

implementation

uses
  SysUtils,
  ConsoleHelper,
  MAI_v2_DLL;


var
  SerialNumber          : Ansistring;
  Result             : Integer;
  SingleVoltage			    : Double;
	CardID,	ChannelNumber, CurrentNumberOfValues, MaxValuesToGet: Cardinal;
  KeyThatWasPressed     : AnsiChar;

begin
	Result					      := -1000;
 	ChannelNumber			    := 0;

	Write('Geben Sie die Seriennummer der gewuenschten Karte an: ');						// Beispiel fr Messungen nach Eingabe der Seriennummer
	Readln(SerialNumber);

  // SerialNumber := '2005-G0A-1024-0-0200';                                  // Eine gltige Seriennummer sieht z.b. so aus

	Result := GetCardIDBySerial(PAnsiChar(SerialNumber), CardID);
	if (Result <> 0) then
	begin
		PrintError(CardID, Result);
	 	Exit;
	end;

  WriteLn;
  Writeln('Name : '+GetCardName(CardID));                                     // Produktbezeichnung der Karte
  WriteLn;

//////////////////////////////////////////////////////////////////////////////////////////////
// Messwerte abholen																		                                    //
//////////////////////////////////////////////////////////////////////////////////////////////

 	MaxValuesToGet			  := 2500;
 	CurrentNumberOfValues	:= 0;
  WriteLn('Lese '+inttostr(MaxValuesToGet)+ ' Werte. (Druecken Sie <ESC> zum Abbrechen.)');
  WriteLn;

	while (CurrentNumberOfValues < MaxValuesToGet) do 											// Bedingung fr Beendigung der Schleife
	begin
    if (KeyPressed(KeyThatWasPressed)) then
    begin
        if(KeyThatWasPressed = #27) then
        begin
           WriteLn('Sie haben <ESC> gedrueckt.');
				   break;
        end;

    end;

 		Result := AD_ReadSingleVoltage(	CardID,				        // ID der anzusprechenden Karte
                                    ChannelNumber,			  // Kanal
                                    oversamplingDISABLED,						// Funktion um Strungen des Messsignals zu reduzieren
                                    gainDisabled,					  // Verstrkungsfaktor
                                    polBIPOLAR,							// Basic-Karten untersttzen nur Bipolar
                                    SingleVoltage);				// Einzelner Spannungswert

		if (Result <> 0) then 												 // Wenn Rckgabewert nicht "0", dann liegt ein Fehler vor
		begin
			PrintError(CardID, Result);
      Exit;
		end;
    Inc( CurrentNumberOfValues );
		Write(Char(13)+'  ' + InttoStr( currentNumberOfValues )+ '/' + InttoStr(  MaxValuesToGet )+'     Spannung: ' +FloattoStr(  SingleVoltage )+' Volt');
		Sleep(1);
	end;

  WriteLn;
  WriteLn;
  Writeln('Fertig. (Bitte <Enter> druecken...)');
  Readln(SerialNumber);

end.
